--- linux-4.11/drivers/media/pci/saa7164/saa7164-api.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-api.c	2017-06-30 13:33:26.629750099 +0200
@@ -560,12 +560,43 @@ int saa7164_api_set_audio_std(struct saa
 		printk(KERN_ERR "%s() error, ret = 0x%x\n", __func__, ret);
 
 	/* Manually select the appropriate TV audio standard */
-	if (port->encodernorm.id & V4L2_STD_NTSC) {
+	if ((port->encodernorm.id & V4L2_STD_NTSC_M) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " NTSC-M Audio\n");
 		tvaudio.std = TU_STANDARD_NTSC_M;
 		tvaudio.country = 1;
-	} else {
+	} else if ((port->encodernorm.id & V4L2_STD_NTSC_M_JP) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " NTSC-M-JP Audio\n");
+		tvaudio.std = TU_STANDARD_NTSC_M_J;
+		tvaudio.country = 81;
+	} else if ((port->encodernorm.id & V4L2_STD_NTSC_443) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " NTSC-443 Audio\n");
+		tvaudio.std = TU_STANDARD_NTSC_433;
+		tvaudio.country = 1;
+	} else if ((port->encodernorm.id & V4L2_STD_PAL_BG) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " PAL-BG Audio\n");
+		tvaudio.std = TU_STANDARD_PAL_B;
+		tvaudio.country = 49;
+	} else if ((port->encodernorm.id & V4L2_STD_PAL_I) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " PAL-I Audio\n");
 		tvaudio.std = TU_STANDARD_PAL_I;
 		tvaudio.country = 44;
+	} else if ((port->encodernorm.id & V4L2_STD_PAL_DK) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " PAL-DK Audio\n");
+		tvaudio.std = TU_STANDARD_PAL_D;
+		tvaudio.country = 48;
+	} else if ((port->encodernorm.id & V4L2_STD_SECAM_L) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " SECAM-L\n");
+		tvaudio.std = TU_STANDARD_SECAM_L;
+		tvaudio.country = 33;
+	} else if ((port->encodernorm.id & V4L2_STD_SECAM_LC) == port->encodernorm.id) {
+		dprintk(DBGLVL_API, " SECAM-Lc Audio\n");
+		tvaudio.std = TU_STANDARD_SECAM_L1;
+		tvaudio.country = 33;
+	} else {
+		/* Unknown standard, set NTSC-M */
+		tvaudio.std = 1;
+		tvaudio.country = 1;
+		dprintk(DBGLVL_API, " Unknown (assuming NTSC-M Audio)\n");
 	}
 
 	ret = saa7164_cmd_send(port->dev, port->tunerunit.unitid, SET_CUR,
@@ -573,6 +604,7 @@ int saa7164_api_set_audio_std(struct saa
 	if (ret != SAA_OK)
 		printk(KERN_ERR "%s() TU_STANDARD_CONTROL error, ret = 0x%x\n",
 			__func__, ret);
+
 	return ret;
 }
 
@@ -627,10 +659,14 @@ static int saa7164_api_set_dif(struct sa
 	dprintk(DBGLVL_API, "%s(nr=%d type=%d val=%x)\n", __func__,
 		port->nr, port->type, val);
 
-	if (port->nr == 0)
+	if (port->nr == SAA7164_PORT_ENC1) {
 		mas = 0xd0;
-	else
+	} else if (port->nr == SAA7164_PORT_ENC2) {
 		mas = 0xe0;
+	} else {
+		printk(KERN_ERR "%s() invalid port nr %d\n", __func__, port->nr);
+		return -EIO;
+	}
 
 	memset(buf, 0, sizeof(buf));
 
@@ -676,50 +712,45 @@ static int saa7164_api_set_dif(struct sa
 int saa7164_api_configure_dif(struct saa7164_port *port, u32 std)
 {
 	struct saa7164_dev *dev = port->dev;
-	u8 agc_disable;
+	int ret = 0;
+	u8 agc_disable = 0;
+	u8 video_standard = 0;
 
 	dprintk(DBGLVL_API, "%s(nr=%d, 0x%x)\n", __func__, port->nr, std);
 
-	if (std & V4L2_STD_NTSC) {
-		dprintk(DBGLVL_API, " NTSC\n");
-		saa7164_api_set_dif(port, 0x00, 0x01); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_PAL_I) {
+	if ((std & V4L2_STD_NTSC_M) == std) {
+		dprintk(DBGLVL_API, " NTSC-M\n");
+		video_standard = 0x01;
+	} else if ((std & V4L2_STD_NTSC_M_JP) == std) {
+		dprintk(DBGLVL_API, " NTSC-M-JP\n");
+		video_standard = 0x01;
+	} else if ((std & V4L2_STD_NTSC_443) == std) {
+		dprintk(DBGLVL_API, " NTSC-443\n");
+		video_standard = 0x01;
+	} else if ((std & V4L2_STD_PAL_BG) == std) {
+		dprintk(DBGLVL_API, " PAL-BG\n");
+		video_standard = 0x02;
+	} else if ((std & V4L2_STD_PAL_I) == std) {
 		dprintk(DBGLVL_API, " PAL-I\n");
-		saa7164_api_set_dif(port, 0x00, 0x08); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_PAL_M) {
-		dprintk(DBGLVL_API, " PAL-M\n");
-		saa7164_api_set_dif(port, 0x00, 0x01); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_PAL_N) {
-		dprintk(DBGLVL_API, " PAL-N\n");
-		saa7164_api_set_dif(port, 0x00, 0x01); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_PAL_Nc) {
-		dprintk(DBGLVL_API, " PAL-Nc\n");
-		saa7164_api_set_dif(port, 0x00, 0x01); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_PAL_B) {
-		dprintk(DBGLVL_API, " PAL-B\n");
-		saa7164_api_set_dif(port, 0x00, 0x02); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_PAL_DK) {
+		video_standard = 0x08;
+	} else if ((std & V4L2_STD_PAL_DK) == std) {
 		dprintk(DBGLVL_API, " PAL-DK\n");
-		saa7164_api_set_dif(port, 0x00, 0x10); /* Video Standard */
-		agc_disable = 0;
-	} else if (std & V4L2_STD_SECAM_L) {
+		video_standard = 0x10;
+	} else if ((std & V4L2_STD_SECAM_L) == std) {
 		dprintk(DBGLVL_API, " SECAM-L\n");
-		saa7164_api_set_dif(port, 0x00, 0x20); /* Video Standard */
-		agc_disable = 0;
+		video_standard = 0x20;
+	} else if ((std & V4L2_STD_SECAM_LC) == std) {
+		dprintk(DBGLVL_API, " SECAM-Lc\n");
+		video_standard = 0x40;
 	} else {
 		/* Unknown standard, assume DTV */
 		dprintk(DBGLVL_API, " Unknown (assuming DTV)\n");
 		/* Undefinded Video Standard */
-		saa7164_api_set_dif(port, 0x00, 0x80);
+		video_standard = 0x80;
 		agc_disable = 1;
 	}
 
+	saa7164_api_set_dif(port, 0x00, video_standard);
 	saa7164_api_set_dif(port, 0x48, 0xa0); /* AGC Functions 1 */
 	saa7164_api_set_dif(port, 0xc0, agc_disable); /* AGC Output Disable */
 	saa7164_api_set_dif(port, 0x7c, 0x04); /* CVBS EQ */
@@ -728,7 +759,7 @@ int saa7164_api_configure_dif(struct saa
 	saa7164_api_set_dif(port, 0x04, 0x00); /* Active (again) */
 	msleep(100);
 
-	return 0;
+	return ret;
 }
 
 /* Ensure the dif is in the correct state for the operating mode
--- linux-4.11/drivers/media/pci/saa7164/saa7164-cards.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-cards.c	2017-06-30 13:33:26.629750099 +0200
@@ -634,6 +634,52 @@ struct saa7164_board saa7164_boards[] =
 			.i2c_reg_len	= REGLEN_0bit,
 		} },
 	},
+	[SAA7164_BOARD_HAUPPAUGE_HVR2215] = {
+		.name		= "Hauppauge WinTV-HVR2215",
+		.porta		= SAA7164_MPEG_DVB,
+		.portb		= SAA7164_MPEG_DVB,
+		.portc		= SAA7164_MPEG_ENCODER,
+		.portd		= SAA7164_MPEG_ENCODER,
+		.porte		= SAA7164_MPEG_VBI,
+		.portf		= SAA7164_MPEG_VBI,
+		.chiprev	= SAA7164_CHIP_REV3,
+		.unit		= {{
+			.id		= 0x28,
+			.type		= SAA7164_UNIT_EEPROM,
+			.name		= "4K EEPROM",
+			.i2c_bus_nr	= SAA7164_I2C_BUS_0,
+			.i2c_bus_addr	= 0xa0 >> 1,
+			.i2c_reg_len	= REGLEN_8bit,
+		}, {
+			.id		= 0x04,
+			.type		= SAA7164_UNIT_TUNER,
+			.name		= "SI2157-1",
+			.i2c_bus_nr	= SAA7164_I2C_BUS_1,	/* physical i2c bus 0 */
+			.i2c_bus_addr	= 0xc0 >> 1,
+			.i2c_reg_len	= 0,
+		}, {
+			.id		= 0x05,
+			.type		= SAA7164_UNIT_DIGITAL_DEMODULATOR,
+			.name		= "SI2168B-1",
+			.i2c_bus_nr	= SAA7164_I2C_BUS_1,	/* physical i2c bus 2 */
+			.i2c_bus_addr	= 0xc8 >> 1,
+			.i2c_reg_len	= 0,
+		}, {
+			.id		= 0x25,
+			.type		= SAA7164_UNIT_TUNER,
+			.name		= "SI2157-2",
+			.i2c_bus_nr	= SAA7164_I2C_BUS_2,	/* physical i2c bus 1 */
+			.i2c_bus_addr	= 0xc0 >> 1,
+			.i2c_reg_len	= 0,
+		}, {
+			.id		= 0x26,
+			.type		= SAA7164_UNIT_DIGITAL_DEMODULATOR,
+			.name		= "SI2168B-2",
+			.i2c_bus_nr	= SAA7164_I2C_BUS_2,
+			.i2c_bus_addr	= 0xcc >> 1,
+			.i2c_reg_len	= 0,
+		} },
+	},
 };
 const unsigned int saa7164_bcount = ARRAY_SIZE(saa7164_boards);
 
@@ -696,6 +742,10 @@ struct saa7164_subid saa7164_subids[] =
 		.subvendor = 0x0070,
 		.subdevice = 0xf120,
 		.card      = SAA7164_BOARD_HAUPPAUGE_HVR2205,
+	}, {
+		.subvendor = 0x0070,
+		.subdevice = 0xf123,
+		.card      = SAA7164_BOARD_HAUPPAUGE_HVR2215,
 	},
 };
 const unsigned int saa7164_idcount = ARRAY_SIZE(saa7164_subids);
@@ -747,6 +797,7 @@ void saa7164_gpio_setup(struct saa7164_d
 	case SAA7164_BOARD_HAUPPAUGE_HVR2255proto:
 	case SAA7164_BOARD_HAUPPAUGE_HVR2255:
 	case SAA7164_BOARD_HAUPPAUGE_HVR2205:
+	case SAA7164_BOARD_HAUPPAUGE_HVR2215:
 		/*
 		HVR2200 / HVR2250
 		GPIO 2: s5h1411 / tda10048-1 demod reset
@@ -858,6 +909,7 @@ void saa7164_card_setup(struct saa7164_d
 	case SAA7164_BOARD_HAUPPAUGE_HVR2255proto:
 	case SAA7164_BOARD_HAUPPAUGE_HVR2255:
 	case SAA7164_BOARD_HAUPPAUGE_HVR2205:
+	case SAA7164_BOARD_HAUPPAUGE_HVR2215:
 		hauppauge_eeprom(dev, &eeprom[0]);
 		break;
 	}
--- linux-4.11/drivers/media/pci/saa7164/saa7164-core.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-core.c	2017-06-30 13:33:26.630750075 +0200
@@ -34,6 +34,7 @@
 MODULE_DESCRIPTION("Driver for NXP SAA7164 based TV cards");
 MODULE_AUTHOR("Steven Toth <stoth@kernellabs.com>");
 MODULE_LICENSE("GPL");
+MODULE_VERSION("2015-07-10");
 
 /*
  *  1 Basic
--- linux-4.11/drivers/media/pci/saa7164/saa7164-dvb.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-dvb.c	2017-06-30 13:33:26.630750075 +0200
@@ -23,6 +23,8 @@
 #include "si2157.h"
 #include "si2168.h"
 #include "lgdt3306a.h"
+#include "si2168b.h"
+#include "silabs_tercab.h"
 
 #define DRIVER_NAME "saa7164"
 
@@ -81,6 +83,95 @@ static struct s5h1411_config hauppauge_s
 	.mpeg_timing   = S5H1411_MPEGTIMING_CONTINOUS_NONINVERTING_CLOCK,
 };
 
+static struct lgdt3306a_config hauppauge_lgdt3306a_1_config = {
+	/* LG3306A demodulator configuration */
+	.i2c_addr           = 0xB2 >> 1,
+
+	/* user defined IF frequency in KHz */
+	.qam_if_khz         = HVR19x5_QAM_IF, /* needs to match tuner */
+	.vsb_if_khz         = HVR19x5_VSB_IF, /* needs to match tuner */
+
+	/* disable i2c repeater - 0:repeater enabled 1:repeater disabled */
+	.deny_i2c_rptr      = 1,
+
+	/* spectral inversion - 0:disabled 1:enabled */
+	.spectral_inversion = 1,
+
+	.mpeg_mode          = LGDT3306A_MPEG_SERIAL,
+	.tpclk_edge         = LGDT3306A_TPCLK_RISING_EDGE,
+	.tpvalid_polarity   = LGDT3306A_TP_VALID_HIGH,
+
+	.xtalMHz            = 25, /* demod clock freq in MHz; 24 or 25 supported */
+};
+
+static struct lgdt3306a_config hauppauge_lgdt3306a_2_config = {
+	/* LG3306A demodulator configuration */
+	.i2c_addr           = 0x1C >> 1,
+
+	/* user defined IF frequency in KHz */
+	.qam_if_khz         = HVR19x5_QAM_IF, /* needs to match tuner */
+	.vsb_if_khz         = HVR19x5_VSB_IF, /* needs to match tuner */
+
+	/* disable i2c repeater - 0:repeater enabled 1:repeater disabled */
+	.deny_i2c_rptr      = 1,
+
+	/* spectral inversion - 0:disabled 1:enabled */
+	.spectral_inversion = 1,
+
+	.mpeg_mode          = LGDT3306A_MPEG_SERIAL,
+	.tpclk_edge         = LGDT3306A_TPCLK_RISING_EDGE,
+	.tpvalid_polarity   = LGDT3306A_TP_VALID_HIGH,
+
+	.xtalMHz            = 25, /* demod clock freq in MHz; 24 or 25 supported */
+};
+
+static struct si2168b_config hauppauge_si2168b_1_config = {
+	/* the demodulator's i2c address */
+	.demod_address = 0xC8 >> 1,
+
+	/* minimum delay before retuning */
+	.min_delay_ms = 85,
+	.ts_bus_mode = 1, /*1-serial, 2-parallel.*/
+	.ts_clock_mode = 1, /*0-auto_fixed, 1-auto_adapt, 2-manual.*/
+	.clk_gapped_en = 1, /*0-disabled, 1-enabled.*/
+	.ts_par_clk_invert = 1, /*0-not-invert, 1-invert*/
+	.ts_par_clk_shift = 1, /*DVB-C QAM256 fix*/
+	.fef_mode = 1, /* needs to match tuner */
+	.fef_pin = 3,
+	.fef_level = 0,
+	.indirect_i2c_connection = 1, /*Si2157 connected directly*/
+	.start_ctrl = NULL,
+};
+
+static struct si2168b_config hauppauge_si2168b_2_config = {
+	/* the demodulator's i2c address */
+	.demod_address = 0xCC >> 1,
+
+	/* minimum delay before retuning */
+	.min_delay_ms = 85,
+	.ts_bus_mode = 1, /*1-serial, 2-parallel.*/
+	.ts_clock_mode = 1, /*0-auto_fixed, 1-auto_adapt, 2-manual.*/
+	.clk_gapped_en = 1, /*0-disabled, 1-enabled.*/
+	.ts_par_clk_invert = 1, /*0-not-invert, 1-invert*/
+	.ts_par_clk_shift = 1, /*DVB-C QAM256 fix*/
+	.fef_mode = 1, /* needs to match tuner */
+	.fef_pin = 3,
+	.fef_level = 0,
+	.indirect_i2c_connection = 1, /*Si2157 connected directly*/
+	.start_ctrl = NULL,
+};
+
+static struct silabs_tercab_config hauppauge_si2157_config = {
+	.tuner_address           = 0xC0 >> 1,      /* address of the tuner for ATSC/DVB-T */
+	.qam_if_khz              = HVR19x5_QAM_IF, /* needs to match demods qam if */
+	.vsb_if_khz              = HVR19x5_VSB_IF, /* needs to match demods vsb if */
+	.tuner_clock_control     = 1, /* 0:always off 1:always on 2:clock managed */
+	.tuner_agc_control       = 1,
+	.fef_mode                = 1, /* fef mode slow normal agc */
+	.crystal_trim_xo_cap     = 8,
+	.indirect_i2c_connection = 1, /* Si2157 connected directly */
+};
+
 static struct lgdt3306a_config hauppauge_hvr2255a_config = {
 	.i2c_addr               = 0xb2 >> 1,
 	.qam_if_khz             = 4000,
@@ -729,6 +820,19 @@ int saa7164_dvb_register(struct saa7164_
 		}
 
 		break;
+	case SAA7164_BOARD_HAUPPAUGE_HVR2215:
+		i2c_bus = &dev->i2c_bus[port->nr + 1];
+
+		port->dvb.frontend = dvb_attach(si2168b_attach,
+			(port->nr == 0) ?
+			&hauppauge_si2168b_1_config : &hauppauge_si2168b_2_config,
+			&i2c_bus->i2c_adap);
+
+		if (port->dvb.frontend != NULL) {
+			dvb_attach(silabs_tercab_attach, port->dvb.frontend,
+				&i2c_bus->i2c_adap,	&hauppauge_si2157_config);
+		}
+		break;
 	default:
 		printk(KERN_ERR "%s: The frontend isn't supported\n",
 		       dev->name);
--- linux-4.11/drivers/media/pci/saa7164/saa7164-encoder.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-encoder.c	2017-06-30 13:33:26.630750075 +0200
@@ -40,6 +40,24 @@ static struct saa7164_tvnorm saa7164_tvn
 	}, {
 		.name      = "NTSC-JP",
 		.id        = V4L2_STD_NTSC_M_JP,
+	}, {
+		.name      = "NTSC-443",
+		.id        = V4L2_STD_NTSC_443,
+	}, {
+		.name      = "PAL-BG",
+		.id        = V4L2_STD_PAL_BG,
+	}, {
+		.name      = "PAL-I",
+		.id        = V4L2_STD_PAL_I,
+	}, {
+		.name      = "PAL-DK",
+		.id        = V4L2_STD_PAL_DK,
+	}, {
+		.name      = "SECAM-L",
+		.id        = V4L2_STD_SECAM_L,
+	}, {
+		.name      = "SECAM-Lc",
+		.id        = V4L2_STD_SECAM_LC,
 	}
 };
 
@@ -215,8 +233,8 @@ int saa7164_s_std(struct saa7164_port *p
 		return -EINVAL;
 
 	port->encodernorm = saa7164_tvnorms[i];
-	port->std = id;
 
+	port->std = id;
 	/* Update the audio decoder while is not running in
 	 * auto detect mode.
 	 */
@@ -1030,6 +1048,7 @@ int saa7164_encoder_register(struct saa7
 	/* Establish encoder defaults here */
 	/* Set default TV standard */
 	port->encodernorm = saa7164_tvnorms[0];
+	port->std = saa7164_tvnorms[0].id;
 	port->width = 720;
 	port->mux_input = 1; /* Composite */
 	port->video_format = EU_VIDEO_FORMAT_MPEG_2;
--- linux-4.11/drivers/media/pci/saa7164/saa7164-fw.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-fw.c	2017-06-30 13:33:26.630750075 +0200
@@ -26,6 +26,9 @@
 #define SAA7164_REV3_FIRMWARE		"NXP7164-2010-03-10.1.fw"
 #define SAA7164_REV3_FIRMWARE_SIZE	4019072
 
+#define SAA7164_HVR2255_FIRMWARE		"NXP7164-2010-04-01.1.fw"
+#define SAA7164_HVR2255_FIRMWARE_SIZE	3283792
+
 struct fw_header {
 	u32	firmwaresize;
 	u32	bslsize;
@@ -214,8 +217,15 @@ int saa7164_downloadfirmware(struct saa7
 		fwname = SAA7164_REV2_FIRMWARE;
 		fwlength = SAA7164_REV2_FIRMWARE_SIZE;
 	} else {
-		fwname = SAA7164_REV3_FIRMWARE;
-		fwlength = SAA7164_REV3_FIRMWARE_SIZE;
+		if (dev->board == SAA7164_BOARD_HAUPPAUGE_HVR2255
+				|| dev->board == SAA7164_BOARD_HAUPPAUGE_HVR2205
+				|| dev->board == SAA7164_BOARD_HAUPPAUGE_HVR2215) {
+			fwname = SAA7164_HVR2255_FIRMWARE;
+			fwlength = SAA7164_HVR2255_FIRMWARE_SIZE;
+		} else {
+			fwname = SAA7164_REV3_FIRMWARE;
+			fwlength = SAA7164_REV3_FIRMWARE_SIZE;
+		}
 	}
 
 	version = saa7164_getcurrentfirmwareversion(dev);
--- linux-4.11/drivers/media/pci/saa7164/saa7164.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164.h	2017-06-30 13:33:26.630750075 +0200
@@ -82,6 +82,7 @@
 #define SAA7164_BOARD_HAUPPAUGE_HVR2255proto	11
 #define SAA7164_BOARD_HAUPPAUGE_HVR2255		12
 #define SAA7164_BOARD_HAUPPAUGE_HVR2205		13
+#define SAA7164_BOARD_HAUPPAUGE_HVR2215		14
 
 #define SAA7164_MAX_UNITS		8
 #define SAA7164_TS_NUMBER_OF_LINES	312
@@ -113,7 +114,8 @@
 #define DBGLVL_CPU 8192
 
 #define SAA7164_NORMS \
-	(V4L2_STD_NTSC_M | V4L2_STD_NTSC_M_JP)
+	(V4L2_STD_NTSC_M | V4L2_STD_NTSC_M_JP | V4L2_STD_NTSC_443 | V4L2_STD_PAL_BG | \
+	 V4L2_STD_PAL_I | V4L2_STD_PAL_DK | V4L2_STD_SECAM_L | V4L2_STD_SECAM_LC)
 
 /* TV frequency range copied from tuner-core.c */
 #define SAA7164_TV_MIN_FREQ (44U * 16U)
--- linux-4.11/drivers/media/pci/saa7164/saa7164-reg.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/pci/saa7164/saa7164-reg.h	2017-06-30 13:33:26.630750075 +0200
@@ -177,7 +177,24 @@
 #define TU_STANDARD_AUTO_CONTROL	0x01
 #define TU_STANDARD_NONE		0x00
 #define TU_STANDARD_NTSC_M		0x01
+#define TU_STANDARD_NTSC_M_J	0x02
+#define TU_STANDARD_NTSC_433	0x03
+#define TU_STANDARD_PAL_B		0x04
+#define TU_STANDARD_PAL_D		0x05
+#define TU_STANDARD_PAL_G		0x06
+#define TU_STANDARD_PAL_H		0x07
 #define TU_STANDARD_PAL_I		0x08
+#define TU_STANDARD_PAL_M		0x09
+#define TU_STANDARD_PAL_N		0x0a
+#define TU_STANDARD_PAL_60		0x0b
+#define TU_STANDARD_SECAM_B		0x0c
+#define TU_STANDARD_SECAM_D		0x0d
+#define TU_STANDARD_SECAM_G		0x0e
+#define TU_STANDARD_SECAM_H		0x0f
+#define TU_STANDARD_SECAM_K		0x10
+#define TU_STANDARD_SECAM_K1	0x11
+#define TU_STANDARD_SECAM_L		0x12
+#define TU_STANDARD_SECAM_L1	0x13
 #define TU_STANDARD_MANUAL		0x00
 #define TU_STANDARD_AUTO		0x01
 
--- linux-4.11/drivers/media/tuners/Kconfig.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/tuners/Kconfig	2017-06-30 14:12:23.241993783 +0200
@@ -248,6 +248,20 @@ config MEDIA_TUNER_SI2157
 	help
 	  Silicon Labs Si2157 silicon tuner driver.
 
+config MEDIA_TUNER_SILABS_TERCAB
+	tristate "Silicon Labs terrestrial/cable tuner series"
+	depends on MEDIA_SUPPORT && I2C
+	default m if !MEDIA_SUBDRV_AUTOSELECT
+	help
+	  Silicon Labs hybrid terrestrial/cable tuner series driver.
+
+config MEDIA_TUNER_SILABS_TERCAB
+	tristate "Silicon Labs terrestrial/cable tuner series"
+	depends on MEDIA_SUPPORT && I2C
+	default m if !MEDIA_SUBDRV_AUTOSELECT
+	help
+	  Silicon Labs hybrid terrestrial/cable tuner series driver.
+
 config MEDIA_TUNER_IT913X
 	tristate "ITE Tech IT913x silicon tuner"
 	depends on MEDIA_SUPPORT && I2C
--- linux-4.11/drivers/media/tuners/silabs_tercab.h.0140~	2017-06-30 13:33:26.632750028 +0200
+++ linux-4.11/drivers/media/tuners/silabs_tercab.h	2017-06-30 13:33:26.632750028 +0200
@@ -0,0 +1,102 @@
+/*
+ * silabs_tercab.h - header for the Silicon Laboratories terrestrial/cable
+ * hybrid tuner series
+ *
+ * (C) Copyright 2014, PCTV Systems S.à r.l
+ * Henning Garbers <hgarbers@pctvsystems.com>
+ *
+ *    This program is free software; you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation; either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    This program is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ */
+
+#ifndef __SILABS_TERCAB_H__
+#define __SILABS_TERCAB_H__
+
+#include <linux/i2c.h>
+#include "dvb_frontend.h"
+
+#define HVR19x5_QAM_IF 4000
+#define HVR19x5_VSB_IF 3250
+
+#define _Si2168B_CLOCK_ALWAYS_OFF 0  /* turn clock ON then never switch it off, used when the clock is provided to another part */
+#define _Si2168B_CLOCK_ALWAYS_ON  1  /* never switch it on, used when the clock is not going anywhere */
+#define _Si2168B_CLOCK_MANAGED    2  /* control clock state as before */
+
+/* settings for the Silicon Labs demod driver */
+#define L1_RF_TER_TUNER_FEF_MODE_FREEZE_PIN_SETUP
+#define L1_RF_TER_TUNER_FEF_MODE_SLOW_INITIAL_AGC_SETUP
+#define L1_RF_TER_TUNER_FEF_MODE_SLOW_NORMAL_AGC_SETUP
+
+/******************************************************************************/
+/* Si2177 Tuner FEF management options */
+/******************************************************************************/
+#define Si2177_FEF_MODE_SLOW_NORMAL_AGC  0
+#define Si2177_FEF_MODE_FREEZE_PIN       1
+#define Si2177_FEF_MODE_SLOW_INITIAL_AGC 2
+
+struct silabs_tercab_config {
+	/* the tuner's i2c address */
+	u8 tuner_address;
+
+	/* user defined IF frequencies in KHz */
+	u16 qam_if_khz;
+	u16 vsb_if_khz;
+
+	/* tuner clock_control:   how the TER clock must be controlled
+       possible modes:
+       CLOCK_ALWAYS_ON  (=0)
+       CLOCK_ALWAYS_OFF (=1)
+	   CLOCK_MANAGED    (=2) */
+	u8 tuner_clock_control;
+
+	/* enable / disable AGC */
+	u8 tuner_agc_control;
+
+	/* FEF management options
+	   FEF_MODE_SLOW_NORMAL_AGC  (=0)
+	   FEF_MODE_FREEZE_PIN       (=1)
+	   FEF_MODE_SLOW_INITIAL_AGC (=2) */
+    u8 fef_mode;
+
+    u8  crystal_trim_xo_cap;
+
+	/* tuner i2c connection               */
+	/* 0-tuner connected through Si2168B  */
+	/* 1-tuner is direct accessible       */
+	u8 indirect_i2c_connection;
+
+	struct dvb_frontend *fe;
+};
+
+#if IS_ENABLED(CONFIG_MEDIA_TUNER_SILABS_TERCAB)
+extern int silabs_tercab_autodetection(struct i2c_adapter* i2c_adapter, u8 i2c_addr);
+
+extern struct dvb_frontend *silabs_tercab_attach(struct dvb_frontend *fe,
+					    struct i2c_adapter *i2c,
+					    struct silabs_tercab_config *cfg);
+#else
+static inline int silabs_tercab_autodetection(struct i2c_adapter* i2c_adapter,
+					u8 i2c_addr)
+{
+	printk(KERN_INFO "%s: not probed - driver disabled by Kconfig\n",
+	       __func__);
+	return -EINVAL;
+}
+
+static inline struct dvb_frontend *silabs_tercab_attach(struct dvb_frontend *fe,
+						   struct i2c_adapter *i2c,
+						   struct silabs_tercab_config *cfg)
+{
+	printk(KERN_WARNING "%s: driver disabled by Kconfig\n", __func__);
+	return NULL;
+}
+#endif
+
+#endif /* __SILABS_TERCAB_H__ */
--- linux-4.11/drivers/media/tuners/tuner-types.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/tuners/tuner-types.c	2017-06-30 13:33:26.635749958 +0200
@@ -1433,6 +1433,16 @@ static struct tuner_params tuner_sony_bt
 	},
 };
 
+/* ------------ TUNER_SILABS_TERCAB - Si2157 NTSC ------------ */
+
+static struct tuner_params tuner_silabs_tercab_params[] = {
+	{
+		.type   = TUNER_PARAM_TYPE_DIGITAL,
+		.ranges = tuner_fm1236_mk3_ntsc_ranges,
+		.count  = ARRAY_SIZE(tuner_fm1236_mk3_ntsc_ranges),
+	},
+};
+
 /* --------------------------------------------------------------------- */
 
 struct tunertype tuners[] = {
@@ -1941,6 +1951,11 @@ struct tunertype tuners[] = {
 		.params = tuner_sony_btf_pg463z_params,
 		.count  = ARRAY_SIZE(tuner_sony_btf_pg463z_params),
 	},
+	[TUNER_SILABS_TERCAB] = {
+		.name   = "Silicon Labs terrestrial/cable multistandard",
+		.params = tuner_silabs_tercab_params,
+		.count  = ARRAY_SIZE(tuner_silabs_tercab_params),
+	},
 };
 EXPORT_SYMBOL(tuners);
 
--- linux-4.11/drivers/media/usb/cx231xx/cx231xx-avcore.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/cx231xx-avcore.c	2017-06-30 13:33:26.635749958 +0200
@@ -355,6 +355,9 @@ int cx231xx_afe_update_power_control(str
 	case CX231XX_BOARD_CNXT_VIDEO_GRABBER:
 	case CX231XX_BOARD_HAUPPAUGE_EXETER:
 	case CX231XX_BOARD_HAUPPAUGE_930C_HD_1113xx:
+	case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+	case CX231XX_BOARD_HAUPPAUGE_935C:
+	case CX231XX_BOARD_HAUPPAUGE_975:
 	case CX231XX_BOARD_HAUPPAUGE_USBLIVE2:
 	case CX231XX_BOARD_PV_PLAYTV_USB_HYBRID:
 	case CX231XX_BOARD_HAUPPAUGE_USB2_FM_PAL:
@@ -599,7 +602,7 @@ int cx231xx_set_video_input_mux(struct c
 				return status;
 			}
 		}
-		if (dev->tuner_type == TUNER_NXP_TDA18271)
+		if (dev->tuner_type == TUNER_NXP_TDA18271 || dev->tuner_type == TUNER_SILABS_TERCAB)
 			status = cx231xx_set_decoder_video_input(dev,
 							CX231XX_VMUX_TELEVISION,
 							INPUT(input)->vmux);
@@ -1209,7 +1212,8 @@ int cx231xx_set_audio_decoder_input(stru
 			   new boards in case they use a tuner type we don't
 			   currently know about */
 			dev_info(dev->dev,
-				 "Unknown tuner type configuring SIF");
+				 "Unknown tuner type %d configuring SIF",
+				 dev->board.tuner_type);
 			break;
 		}
 		break;
@@ -1750,6 +1754,9 @@ int cx231xx_dif_set_standard(struct cx23
 	case CX231XX_BOARD_CNXT_RDU_250:
 	case CX231XX_BOARD_CNXT_VIDEO_GRABBER:
 	case CX231XX_BOARD_HAUPPAUGE_EXETER:
+	case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+	case CX231XX_BOARD_HAUPPAUGE_935C:
+	case CX231XX_BOARD_HAUPPAUGE_975:
 	case CX231XX_BOARD_OTG102:
 		func_mode = 0x03;
 		break;
--- linux-4.11/drivers/media/usb/cx231xx/cx231xx-cards.c.0140~	2017-06-30 13:33:26.530752430 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/cx231xx-cards.c	2017-06-30 13:33:26.635749958 +0200
@@ -34,6 +34,7 @@
 #include "dvb-usb-ids.h"
 #include "xc5000.h"
 #include "tda18271.h"
+#include "si2157.h"
 
 
 static int tuner = -1;
@@ -376,6 +377,123 @@ struct cx231xx_board cx231xx_boards[] =
 			.gpio = NULL,
 		} },
 	},
+	[CX231XX_BOARD_HAUPPAUGE_EXETER_955Q] = {
+		.name = "Hauppauge EXETER 955Q",
+		.tuner_type = TUNER_SILABS_TERCAB,
+		.tuner_addr = 0x60,
+		.tuner_gpio = RDE250_XCV_TUNER,
+		.tuner_sif_gpio = -1, //0x05,
+		.tuner_scl_gpio = -1, //0x1a,
+		.tuner_sda_gpio = -1, //0x1b,
+		.decoder = CX231XX_AVDECODER,
+		.output_mode = OUT_MODE_VIP11,
+		.demod_xfer_mode = 0,
+		.ctl_pin_status_mask = 0xFFFFFFC4,
+		.agc_analog_digital_select_gpio = 0x0c,
+		.gpio_pin_status_mask = 0x4001000,
+		.tuner_i2c_master = I2C_1_MUX_3,
+		.demod_i2c_master = I2C_2,
+		.has_dvb = 1,
+		.demod_addr = 0xB2 >> 1,
+		.norm = V4L2_STD_NTSC,
+
+		.input = {{
+			.type = CX231XX_VMUX_TELEVISION,
+			.vmux = CX231XX_VIN_3_1,
+			.amux = CX231XX_AMUX_VIDEO,
+			.gpio = NULL,
+		}, {
+			.type = CX231XX_VMUX_COMPOSITE1,
+			.vmux = CX231XX_VIN_2_1,
+			.amux = CX231XX_AMUX_LINE_IN,
+			.gpio = NULL,
+		}, {
+			.type = CX231XX_VMUX_SVIDEO,
+			.vmux = CX231XX_VIN_1_1 |
+				(CX231XX_VIN_1_2 << 8) |
+				CX25840_SVIDEO_ON,
+			.amux = CX231XX_AMUX_LINE_IN,
+			.gpio = NULL,
+		} },
+	},
+	[CX231XX_BOARD_HAUPPAUGE_935C] = {
+		.name = "Hauppauge WinTV 935C",
+		.tuner_type = TUNER_SILABS_TERCAB,
+		.tuner_addr = 0x60,
+		.tuner_gpio = RDE250_XCV_TUNER,
+		.tuner_sif_gpio = -1, //0x05,
+		.tuner_scl_gpio = -1, //0x1a,
+		.tuner_sda_gpio = -1, //0x1b,
+		.decoder = CX231XX_AVDECODER,
+		.output_mode = OUT_MODE_VIP11,
+		.demod_xfer_mode = 0,
+		.ctl_pin_status_mask = 0xFFFFFFC4,
+		.agc_analog_digital_select_gpio = 0x0c,
+		.gpio_pin_status_mask = 0x4001000,
+		.tuner_i2c_master = I2C_1_MUX_3,
+		.demod_i2c_master = I2C_2,
+		.has_dvb = 1,
+		.demod_addr = 0xC8 >> 1,
+		.norm = V4L2_STD_PAL,
+
+		.input = {{
+			.type = CX231XX_VMUX_TELEVISION,
+			.vmux = CX231XX_VIN_3_1,
+			.amux = CX231XX_AMUX_VIDEO,
+			.gpio = NULL,
+		}, {
+			.type = CX231XX_VMUX_COMPOSITE1,
+			.vmux = CX231XX_VIN_2_1,
+			.amux = CX231XX_AMUX_LINE_IN,
+			.gpio = NULL,
+		}, {
+			.type = CX231XX_VMUX_SVIDEO,
+			.vmux = CX231XX_VIN_1_1 |
+				(CX231XX_VIN_1_2 << 8) |
+				CX25840_SVIDEO_ON,
+			.amux = CX231XX_AMUX_LINE_IN,
+			.gpio = NULL,
+		} },
+	},
+	[CX231XX_BOARD_HAUPPAUGE_975] = {
+		.name = "Hauppauge WinTV 975",
+		.tuner_type = TUNER_SILABS_TERCAB,
+		.tuner_addr = 0x60,
+		.tuner_gpio = RDE250_XCV_TUNER,
+		.tuner_sif_gpio = -1, //0x05,
+		.tuner_scl_gpio = -1, //0x1a,
+		.tuner_sda_gpio = -1, //0x1b,
+		.decoder = CX231XX_AVDECODER,
+		.output_mode = OUT_MODE_VIP11,
+		.demod_xfer_mode = 0,
+		.ctl_pin_status_mask = 0xFFFFFFC4,
+		.agc_analog_digital_select_gpio = 0x0c,
+		.gpio_pin_status_mask = 0x4001000,
+		.tuner_i2c_master = I2C_1_MUX_3,
+		.demod_i2c_master = I2C_2,
+		.has_dvb = 1,
+		.demod_addr = -1,
+		.norm = V4L2_STD_PAL,
+
+		.input = {{
+			.type = CX231XX_VMUX_TELEVISION,
+			.vmux = CX231XX_VIN_3_1,
+			.amux = CX231XX_AMUX_VIDEO,
+			.gpio = NULL,
+		}, {
+			.type = CX231XX_VMUX_COMPOSITE1,
+			.vmux = CX231XX_VIN_2_1,
+			.amux = CX231XX_AMUX_LINE_IN,
+			.gpio = NULL,
+		}, {
+			.type = CX231XX_VMUX_SVIDEO,
+			.vmux = CX231XX_VIN_1_1 |
+				(CX231XX_VIN_1_2 << 8) |
+				CX25840_SVIDEO_ON,
+			.amux = CX231XX_AMUX_LINE_IN,
+			.gpio = NULL,
+		} },
+	},
 	[CX231XX_BOARD_HAUPPAUGE_USBLIVE2] = {
 		.name = "Hauppauge USB Live 2",
 		.tuner_type = TUNER_ABSENT,
@@ -911,6 +1029,12 @@ struct usb_device_id cx231xx_id_table[]
 	 .driver_info = CX231XX_BOARD_HAUPPAUGE_930C_HD_1114xx},
 	{USB_DEVICE(0x2040, 0xb140),
 	 .driver_info = CX231XX_BOARD_HAUPPAUGE_EXETER},
+	{USB_DEVICE(0x2040, 0xb151),
+	 .driver_info = CX231XX_BOARD_HAUPPAUGE_935C},
+	{USB_DEVICE(0x2040, 0xb123),
+	 .driver_info = CX231XX_BOARD_HAUPPAUGE_EXETER_955Q},
+	{USB_DEVICE(0x2040, 0xb150),
+	 .driver_info = CX231XX_BOARD_HAUPPAUGE_975},
 	{USB_DEVICE(0x2040, 0xc200),
 	 .driver_info = CX231XX_BOARD_HAUPPAUGE_USBLIVE2},
 	/* PCTV QuatroStick 521e */
@@ -966,7 +1090,7 @@ int cx231xx_tuner_callback(void *ptr, in
 					       1);
 			msleep(10);
 		}
-	} else if (dev->tuner_type == TUNER_NXP_TDA18271) {
+	} else if (dev->tuner_type == TUNER_NXP_TDA18271 || dev->tuner_type == TUNER_SILABS_TERCAB) {
 		switch (command) {
 		case TDA18271_CALLBACK_CMD_AGC_ENABLE:
 			if (dev->model == CX231XX_BOARD_PV_PLAYTV_USB_HYBRID)
@@ -1110,7 +1234,6 @@ static int read_eeprom(struct cx231xx *d
 
 void cx231xx_card_setup(struct cx231xx *dev)
 {
-
 	cx231xx_set_model(dev);
 
 	dev->tuner_type = cx231xx_boards[dev->model].tuner_type;
@@ -1148,6 +1271,9 @@ void cx231xx_card_setup(struct cx231xx *
 	case CX231XX_BOARD_HAUPPAUGE_930C_HD_1113xx:
 	case CX231XX_BOARD_HAUPPAUGE_930C_HD_1114xx:
 	case CX231XX_BOARD_HAUPPAUGE_955Q:
+	case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+	case CX231XX_BOARD_HAUPPAUGE_935C:
+	case CX231XX_BOARD_HAUPPAUGE_975:
 		{
 			struct eeprom {
 				struct tveeprom tvee;
--- linux-4.11/drivers/media/usb/cx231xx/cx231xx-core.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/cx231xx-core.c	2017-06-30 13:33:26.635749958 +0200
@@ -720,6 +720,9 @@ int cx231xx_set_mode(struct cx231xx *dev
 			break;
 		case CX231XX_BOARD_HAUPPAUGE_EXETER:
 		case CX231XX_BOARD_HAUPPAUGE_930C_HD_1113xx:
+		case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+		case CX231XX_BOARD_HAUPPAUGE_935C:
+		case CX231XX_BOARD_HAUPPAUGE_975:
 			errCode = cx231xx_set_power_mode(dev,
 						POLARIS_AVMODE_DIGITAL);
 			break;
@@ -739,6 +742,9 @@ int cx231xx_set_mode(struct cx231xx *dev
 		case CX231XX_BOARD_CNXT_RDU_253S:
 		case CX231XX_BOARD_HAUPPAUGE_EXETER:
 		case CX231XX_BOARD_HAUPPAUGE_930C_HD_1113xx:
+		case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+		case CX231XX_BOARD_HAUPPAUGE_935C:
+		case CX231XX_BOARD_HAUPPAUGE_975:
 		case CX231XX_BOARD_PV_PLAYTV_USB_HYBRID:
 		case CX231XX_BOARD_HAUPPAUGE_USB2_FM_PAL:
 		case CX231XX_BOARD_HAUPPAUGE_USB2_FM_NTSC:
@@ -1440,6 +1446,9 @@ int cx231xx_dev_init(struct cx231xx *dev
 	case CX231XX_BOARD_CNXT_RDU_253S:
 	case CX231XX_BOARD_HAUPPAUGE_EXETER:
 	case CX231XX_BOARD_HAUPPAUGE_930C_HD_1113xx:
+	case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+	case CX231XX_BOARD_HAUPPAUGE_935C:
+	case CX231XX_BOARD_HAUPPAUGE_975:
 	case CX231XX_BOARD_PV_PLAYTV_USB_HYBRID:
 	case CX231XX_BOARD_HAUPPAUGE_USB2_FM_PAL:
 	case CX231XX_BOARD_HAUPPAUGE_USB2_FM_NTSC:
